# Create Contacts

> Source: https://truto.one/docs/api-reference/unified-accounting-api/contacts/create/

`POST /unified/accounting/contacts`

Resource: **Contacts** · API: **Unified Accounting API**

## Supported integrations

Microsoft Dynamics 365 Business Central, QuickBooks, Sage Intacct, Xero

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`contact_type`** _(string)_
  The type of the contact
  Allowed: `customer`, `vendor`

## Request body

- **`name`** _(string)_
  The name of the contact
- **`type`** _(string)_
  The type of the contact
  Allowed: `customer`, `vendor`, `customer`, `vendor`
- **`emails`** _(array<object>)_
  The emails of the contact
  - **`email`** _(string)_
    The email of the contact
  - **`type`** _(string)_
    The type of the email
- **`tax_number`** _(string)_
  The tax number of the contact
- **`status`** _(string)_
  The status of the contact
  Allowed: `active`, `archived`, `active`, `archived`
- **`addresses`** _(array<object>)_
  The addresses of the contact
  - **`id`** _(string)_
    The unique identifier for address
  - **`street_1`** _(string)_
    The street 1 address of the contact
  - **`street_2`** _(string)_
    The street 2 address of the contact
  - **`city`** _(string)_
    The city of the contact
  - **`state`** _(string)_
    The state of the contact
  - **`country`** _(string)_
    The country of the contact
  - **`postal_code`** _(string)_
    The postal code of the contact
  - **`type`** _(string)_
    The type of the address
- **`phones`** _(array<object>)_
  The phone numbers of the contact
  - **`number`** _(string)_
    The phone number of the contact
  - **`extension`** _(string)_
    The extension of the phone number
  - **`type`** _(string)_
    The type of the phone number
- **`currency`** _(string)_
  The currency of the contact
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for the contact
- **`name`** _(string)_
  The name of the contact
- **`type`** _(string)_
  The type of the contact
  Allowed: `customer`, `vendor`
- **`emails`** _(array<object>)_
  The emails of the contact
  - **`email`** _(string)_
    The email of the contact
  - **`type`** _(string)_
    The type of the email
- **`tax_number`** _(string)_
  The tax number of the contact
- **`status`** _(string)_
  The status of the contact
  Allowed: `active`, `archived`
- **`currency`** _(string)_
  The currency of the contact
- **`company`** _(string)_
  The ID of company the contact belongs to
- **`addresses`** _(array<object>)_
  The addresses of the contact
  - **`id`** _(string)_
    The unique identifier for address
  - **`street_1`** _(string)_
    The street 1 address of the contact
  - **`street_2`** _(string)_
    The street 2 address of the contact
  - **`city`** _(string)_
    The city of the contact
  - **`state`** _(string)_
    The state of the contact
  - **`country`** _(string)_
    The country of the contact
  - **`postal_code`** _(string)_
    The postal code of the contact
  - **`type`** _(string)_
    The type of the address
- **`phones`** _(array<object>)_
  The phone numbers of the contact
  - **`number`** _(string)_
    The phone number of the contact
  - **`extension`** _(string)_
    The extension of the phone number
  - **`type`** _(string)_
    The type of the phone number
- **`created_at`** _(string)_
  This represents the date when the contact was created
- **`updated_at`** _(string)_
  This represents the date when the contact was updated
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/accounting/contacts?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "name": "your_name",
  "type": "customer",
  "emails": [],
  "tax_number": "your_tax_number",
  "status": "active",
  "addresses": [],
  "phones": [],
  "currency": "your_currency",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "name": "your_name",
  "type": "customer",
  "emails": [],
  "tax_number": "your_tax_number",
  "status": "active",
  "addresses": [],
  "phones": [],
  "currency": "your_currency",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/accounting/contacts?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/accounting/contacts"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "name": "your_name",
    "type": "customer",
    "emails": [],
    "tax_number": "your_tax_number",
    "status": "active",
    "addresses": [],
    "phones": [],
    "currency": "your_currency",
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'accounting',
  'contacts',
  {
  "name": "your_name",
  "type": "customer",
  "emails": [],
  "tax_number": "your_tax_number",
  "status": "active",
  "addresses": [],
  "phones": [],
  "currency": "your_currency",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "accounting",
        "contacts",
        {
        "name": "your_name",
        "type": "customer",
        "emails": [],
        "tax_number": "your_tax_number",
        "status": "active",
        "addresses": [],
        "phones": [],
        "currency": "your_currency",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
